# -*- coding: utf-8 -*-
import dm
import dm.models
import os
import logging
import logging.config
from xml.etree import ElementTree


logging.config.fileConfig("log.ini")
logging.getLogger('urllib3').setLevel(logging.WARN)

client = dm.Client(token="TjMgcEtjGyL2qXZ4", token_secret="xBJS0Oq9j5Hjc8Kq")

def main():
    user = client.get_user(8)
    logging.info("{} token={} secret={}".format(user, user.credentials.key, user.credentials.secret))

    for ingest in client.get_ingests():
        logging.info("Found {}".format(ingest))

    for obj in client.get_objects():
        logging.info("Found {}".format(obj))

    ap = client.get_accesspoints('file://')[0]
    downloads = {d.object_uuid: d for d in client.get_downloads()}
    objects = {obj: obj.uuid for obj in client.get_objects() if obj.label == 'raw'}

    for obj, uuid in objects.items():
        if uuid in downloads:
            download = downloads[uuid]
            logging.info("Using download={} for object={}".format(download, obj))
        else:
            logging.warn("No download for {}".format(obj))
            download = obj.create_download(ap)
            logging.info("Created {}".format(download))


def delete_objects():
    for obj in client.get_objects(predicate=lambda o: o.label == 'foo2'):
        try:
            client.delete_object(obj)
        except dm.exceptions.ArbitraryError as e:
            logging.error("Could not delete {}".format(obj))


if __name__ == '__main__':
    main()
